
var currentHREFNode = null;
var currentIMGNode = null;
var STATUS_SELECT_IMAGE=80;

function insertTableRow(){
	if (updateSelection()) {
		var selectedNode = selectionRange.parentElement();
		if(selectedNode!=null){
			var rowNode = null;
			var currentNode = selectedNode;
			while(currentNode){
				if(currentNode.nodeName=="TR"){
					rowNode = currentNode;
					break;
				}
				currentNode = currentNode.parentNode;
			}
			if(rowNode){
				// Now count how many columns it has
				var columnCount = rowNode.childNodes.length;
				// Create the DOM
				var newRow = editorDoc.createElement("TR");
				for(var cc=0; cc<columnCount; cc++){
					var newCol = editorDoc.createElement("TD");
					newRow.appendChild(newCol);
				}
				// Now insert the new row
				rowNode.parentNode.insertBefore(newRow, rowNode);
				setStatus(STATUS_EXEC_CMD, 1);
				setStatus(STATUS_MODIFIED, null);
			}
		}
	}
}

function insertTableColumn(){
	if (updateSelection()) {
		var selectedNode = selectionRange.parentElement();
		if(selectedNode!=null){
			var rowNode = null;
			var colNode = null;
			var currentNode = selectedNode;
			while(currentNode){
				if(currentNode.nodeName=="TR"){
					rowNode = currentNode;
					break;
				}
				if(currentNode.nodeName=="TD"){
					colNode = currentNode;
				}
				currentNode = currentNode.parentNode;
			}
			if(rowNode && colNode){
				// Now count how many columns it has
				var columnCount = rowNode.childNodes.length;
				// Now count our index in the children
				var colPosition = 0;
				for(var cc=0;cc<columnCount;cc++){
					if(rowNode.childNodes[cc]==colNode){
						colPosition = cc;
						break;
					}
				}
				// Create the <td> for all <tr>'s 
				var rowParent = rowNode.parentNode;
				for(var rc=0; rc<rowParent.childNodes.length; rc++){
					var row = rowParent.childNodes[rc];
					if(row.childNodes.length>colPosition){
						var newCol = editorDoc.createElement("TD");
						row.insertBefore(newCol, row.childNodes[colPosition]);
					}
				}
				setStatus(STATUS_EXEC_CMD, 1);
				setStatus(STATUS_MODIFIED, null);
			}
		}
	}
}


function deleteTableRow(){
	if (updateSelection()) {
		var selectedNode = selectionRange.parentElement();
		if(selectedNode!=null){
			var rowNode = null;
			var currentNode = selectedNode;
			while(currentNode){
				if(currentNode.nodeName=="TR"){
					rowNode = currentNode;
					break;
				}
				currentNode = currentNode.parentNode;
			}
			if(rowNode){
				var rowParent = rowNode.parentNode;
				rowParent.removeChild(rowNode);
				setStatus(STATUS_EXEC_CMD, 1);
				setStatus(STATUS_MODIFIED, null);
			}
		}
	}
}

function deleteTableColumn(){
	if (updateSelection()) {
		var selectedNode = selectionRange.parentElement();
		if(selectedNode!=null){
			var rowNode = null;
			var colNode = null;
			var currentNode = selectedNode;
			while(currentNode){
				if(currentNode.nodeName=="TR"){
					rowNode = currentNode;
					break;
				}
				if(currentNode.nodeName=="TD"){
					colNode = currentNode;
				}
				currentNode = currentNode.parentNode;
			}
			if(rowNode && colNode){
				// Now count how many columns it has
				var columnCount = rowNode.childNodes.length;
				// Now count our index in the children
				var colPosition = 0;
				for(var cc=0;cc<columnCount;cc++){
					if(rowNode.childNodes[cc]==colNode){
						colPosition = cc;
						break;
					}
				}
				// Create the <td> for all <tr>'s 
				var rowParent = rowNode.parentNode;
				for(var rc=0; rc<rowParent.childNodes.length; rc++){
					var row = rowParent.childNodes[rc];
					if(row.childNodes.length>colPosition){
						row.removeChild(row.childNodes[colPosition]);
					}
				}
				setStatus(STATUS_EXEC_CMD, 1);
				setStatus(STATUS_MODIFIED, null);
			}
		}
	}
}

function ramLookForHREF(){
	urlName = "";
	urlValue = "";
	currentHREFNode = null;
	if(selection!=null){
		var selectedNode = selectionRange.parentElement();
		if(selectedNode!=null){
			var currentNode = selectedNode;
			while(currentNode){
				if(currentNode.nodeName=="A"){
					currentHREFNode = currentNode;
					break;
				}
				currentNode = currentNode.parentNode;
			}
			if(currentHREFNode){
				urlValue = currentHREFNode.href;
				urlName = currentHREFNode.innerHTML;
			}
		}
	}
	window.status = "RAMHREF:"+urlName+":"+urlValue;
	setStatus(STATUS_EXEC_CMD, 1);
	setStatus(STATUS_MODIFIED, null);
}

function ramUpdateHREF(urlValue){
	if(currentHREFNode){
		currentHREFNode.href = urlValue;
	}
	setStatus(STATUS_EXEC_CMD, 1);
	setStatus(STATUS_MODIFIED, null);
}

function ramLookForIMG(){
	urlName = "";
	urlValue = "";
	currentIMGNode = null;
	if(selection!=null){
		var selectedNode = selectionRange.parentElement();
		if(selectedNode!=null){
			var currentNode = selectedNode;
			while(currentNode){
				if(currentNode.nodeName=="IMG"){
					currentIMGNode = currentNode;
					break;
				}
				currentNode = currentNode.parentNode;
			}
			if(currentIMGNode){
				urlValue = currentIMGNode.src;
			}
		}
	}
	window.status = "RAMIMG:"+urlValue;
	setStatus(STATUS_EXEC_CMD, 1);
	setStatus(STATUS_MODIFIED, null);
}

function ramUpdateIMG(urlValue){
	if(currentIMGNode){
		currentIMGNode.src = urlValue;
	}
	setStatus(STATUS_EXEC_CMD, 1);
	setStatus(STATUS_MODIFIED, null);
}

function updateRAMSelection(){
	contentWindow = document.getElementById(editorId).contentWindow;
	editorDoc = contentWindow.document;
	if (document.all) {
		selection = editorDoc.selection;
		if (selection != null) {
			selectionRange = selection.createRange();
			if (selectionRange != null) {
					if (selection.type != "Control") {
						tempSelRange = selectionRange.duplicate();
					} else {
						if (selectionRange(0).tagName == "IMG") {
							currentSelectedImg = selectionRange(0);
							//imgHTML = currentSelectedImg.parentNode.innerHTML;
							imgHTML = currentSelectedImg.src;
							currentIMGNode = currentSelectedImg;
							setStatus(STATUS_SELECT_IMAGE, imgHTML);
						}
					}
			}
			reformatElementLinks();
		}
	}else {
		selection = contentWindow.getSelection();
		if (selection != null) {
			selectionRange = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
			var imgNode = null;
			if (selectionRange.startContainer && selectionRange.endContainer &&
					selectionRange.startContainer == selectionRange.endContainer &&
					selectionRange.startContainer.nodeType == 1){
				if (selectionRange.startContainer.tagName == "IMG"){
					imgNode = selectionRange.startContainer;
				} else if (selectionRange.endOffset - selectionRange.startOffset == 1 &&
						selectionRange.startContainer.childNodes[selectionRange.startOffset].tagName == "IMG"){
					imgNode = selectionRange.startContainer.childNodes[selectionRange.startOffset];
				}
			}
			if ( imgNode != null ){
				currentSelectedImg = imgNode;
				//imgHTML = currentIMGNode.parentNode.innerHTML;
				imgHTML = currentSelectedImg.src;
				setStatus(STATUS_SELECT_IMAGE, imgHTML);
				currentIMGNode = currentSelectedImg;
			} else {
				tempSelRange = selectionRange.cloneRange();
			} 
		}
	}
}

function doSelectionChanged(event) {
	updateRAMSelection();
}

function hookRAMListeners(){
	var doc = document.getElementById("rte").contentWindow.document;
	doc.attachEvent("onselectionchange", doSelectionChanged);
}
