/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem;

import java.util.Map;

import com.ibm.ram.common.data.Asset;
import com.ibm.ram.common.data.AssetType;

/**
 * 
 * @author ebordeau
 * @since 7.1
 */
public class AssetTypeRule extends AbstractRule {
	
	static final String ASSET_TYPE_NAME = "assetType"; //$NON-NLS-1$
	public static final String ID = AssetTypeRule.class.getName();
	
	private String assetTypeName;
	
	public void initialize(Map config) {
		super.initialize(config);
		setAssetTypeName((String)config.get(ASSET_TYPE_NAME));
	}

	public void save(Map config) {
		super.save(config);
		config.put(ASSET_TYPE_NAME, assetTypeName);
	}
	
	public boolean applyValue(Asset asset) {
		if (assetTypeName != null && assetTypeName.length() > 0) {
			AssetType assetType = new AssetType();
			assetType.setName(assetTypeName);
			asset.setAssetType(assetType);
			return true;
		}
		return false;
	}
	
	public String getId() {
		return ID;
	}
	
	public void setAssetTypeName(String name) {
		assetTypeName = name;
	}

}
