/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem;

import org.eclipse.ui.views.properties.*;

import com.ibm.ram.internal.rich.ui.util.Messages;

/**
 * @author ebordeau
 *
 */
public class DataSourcePropertySource implements IPropertySource {
	
	public static final String ROOT_DIR_ID = "rootdir"; //$NON-NLS-1$

	private final FileSystemDataSource dataSource;

	public DataSourcePropertySource(FileSystemDataSource dataSource) {
		this.dataSource = dataSource;
	}

	public Object getEditableValue() {
		return this;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		return new IPropertyDescriptor[] {
			new TextPropertyDescriptor(ROOT_DIR_ID, Messages.Batch_FileSystem_Rule_Filter),
		};
	}

	public Object getPropertyValue(Object id) {
		if (ROOT_DIR_ID.equals(id)) 
			return dataSource.getRootPath();
		return null;
	}

	public boolean isPropertySet(Object id) {
		return false;
	}

	public void resetPropertyValue(Object id) {}

	public void setPropertyValue(Object id, Object value) {
		if (ROOT_DIR_ID.equals(id)) 
			dataSource.setRootPath((String)value);
	}

}
