/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem;

/**
 * Represents a source object to which rules are applied.
 * 
 * @author ebordeau
 * @since 7.1
 */
public interface IRuleSource {
	
	/**
	 * Returns the children of the given IRuleSource that match this rule's filters.
	 * 
	 * @param parent the parent object
	 * @return the filtered children
	 */
	IRuleSource[] filter(IRuleSource parent);
	
	/**
	 * @return the name of this rule source
	 */
	String getName();
	
	/**
	 * @return the content of this rule source
	 */
	Object getContent();
	
	/**
	 * Sets the excludes filter
	 */
	void setExcludes(String excludes);
	
	void setIncludes(String includes);

}
