/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem;

import java.util.Map;

import com.ibm.ram.common.data.Asset;

/**
 * 
 * @author ebordeau
 * @since 7.1
 */
public class NameRule extends AbstractRule {

	static final String NAME = "name"; //$NON-NLS-1$
	public static final String ID = NameRule.class.getName();
	
	private String name;
	
	public void initialize(Map config) {
		super.initialize(config);
		setName((String)config.get(NAME));
	}

	public void save(Map config) {
		super.save(config);
		config.put(NAME, name);
	}
	
	public boolean applyValue(Asset asset) {
		if (name != null && name.length() > 0) {
			asset.setName(name);
			return true;
		}
		return false;
	}
	
	public String getId() {
		return ID;
	}
	
	public void setName(String name) {
		this.name = name;
	}

}
