/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem;

import java.util.Map;


/**
 * 
 * @author ebordeau
 * @since 7.1
 */
public class RelatedAssetRule extends AbstractRule {

	static final String RELATIONSHIP_TYPE = "relationshipType"; //$NON-NLS-1$
	static final String GUID = "guid"; //$NON-NLS-1$
	static final String VERSION = "version"; //$NON-NLS-1$
	public static final String ID = RelatedAssetRule.class.getName();
	
	private String relationshipType;
	private String guid;
	private String version;
	
	public void initialize(Map config) {
		super.initialize(config);
		setRelationshipType((String)config.get(RELATIONSHIP_TYPE));
		setGuid((String)config.get(GUID));
		setVersion((String)config.get(VERSION));
	}

	public void save(Map config) {
		super.save(config);
		config.put(RELATIONSHIP_TYPE, relationshipType);
		config.put(GUID, guid);
		config.put(VERSION, version);
	}
	
	public String getId() {
		return ID;
	}
	
	public String getRelationshipType() {
		return relationshipType;
	}

	public String getGuid() {
		return guid;
	}

	public String getVersion() {
		return version;
	}

	public void setRelationshipType(String relationshipType) {
		this.relationshipType = relationshipType;
	}

	public void setGuid(String guid) {
		this.guid = guid;
	}

	public void setVersion(String version) {
		this.version = version;
	}

}
