/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
package com.ibm.ram.internal.batch.filesystem;

public class RuleFactory {

	public static IRule createRule(String typeId) {
		if (typeId.equals(AssetRule.ID))
			return new AssetRule();
		if (typeId.equals(CommunityRule.ID))
			return new CommunityRule();
		if (typeId.equals(ArtifactRule.ID))
			return new ArtifactRule();
		if (typeId.equals(AssetTypeRule.ID))
			return new AssetTypeRule();
		if (typeId.equals(AttributeRule.ID))
			return new AttributeRule();
		if (typeId.equals(CategoryRule.ID))
			return new CategoryRule();
		if (typeId.equals(DescriptionRule.ID))
			return new DescriptionRule();
		if (typeId.equals(NameRule.ID))
			return new NameRule();
		if (typeId.equals(OwnerRule.ID))
			return new OwnerRule();
		if (typeId.equals(RelatedAssetRule.ID))
			return new RelatedAssetRule();
		if (typeId.equals(ShortDescriptionRule.ID))
			return new ShortDescriptionRule();
		if (typeId.equals(VersionRule.ID))
			return new VersionRule();
		return null;
	}

}
