/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem;

import org.eclipse.ui.views.properties.*;

import com.ibm.ram.internal.rich.ui.util.Messages;

/**
 * @author ebordeau
 *
 */
public class RulePropertySource implements IPropertySource {
	
	public static final String FILTER_ID = "filter"; //$NON-NLS-1$
	public static final String VALUE_ID = "value"; //$NON-NLS-1$

	private final IRule rule;

	public RulePropertySource(IRule rule) {
		this.rule = rule;
	}

	public Object getEditableValue() {
		return this;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		return new IPropertyDescriptor[] {
			new TextPropertyDescriptor(FILTER_ID, Messages.Batch_FileSystem_Rule_Filter),
			new TextPropertyDescriptor(VALUE_ID, Messages.Batch_FileSystem_Rule_Value)
		};
	}

	public Object getPropertyValue(Object id) {
		if (FILTER_ID.equals(id)) 
			return rule.getFilter();
		if (VALUE_ID.equals(id)) 
			return rule.getValue();
		return null;
	}

	public boolean isPropertySet(Object id) {
		return false;
	}

	public void resetPropertyValue(Object id) {}

	public void setPropertyValue(Object id, Object value) {
		if (FILTER_ID.equals(id)) 
			rule.setFilter((String)value);
		else if (VALUE_ID.equals(id)) 
			rule.setValue((String)value);
	}

}
