/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem;

import java.util.Map;

import com.ibm.ram.common.data.Asset;

/**
 * 
 * @author ebordeau
 * @since 7.1
 */
public class ShortDescriptionRule extends AbstractRule {
	
	static final String SHORT_DESCRIPTION = "shortDescription"; //$NON-NLS-1$
	public static final String ID = ShortDescriptionRule.class.getName();
	
	private String shortDesc;
	
	public void initialize(Map config) {
		super.initialize(config);
		setShortDescription((String)config.get(SHORT_DESCRIPTION));
	}

	public void save(Map config) {
		super.save(config);
		config.put(SHORT_DESCRIPTION, shortDesc);
	}
	
	public boolean applyValue(Asset asset) {
		if (shortDesc != null && shortDesc.length() > 0) {
			asset.setShortDescription(shortDesc);
			return true;
		}
		return false;
	}

	public String getId() {
		return ID;
	}
	
	public void setShortDescription(String shortDesc) {
		this.shortDesc = shortDesc;
	}

}
