/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem.ui;

import java.util.Iterator;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;

import com.ibm.ram.batch.ui.IBatchClientEditor;
import com.ibm.ram.internal.batch.filesystem.IRule;
import com.ibm.ram.internal.batch.ui.BatchUpdateEditor;

/**
 * 
 * @author ebordeau
 * @since 7.1
 */
public class DeleteRuleAction implements IEditorActionDelegate {
	
	private IBatchClientEditor editor;
	private IStructuredSelection selection;
	
	public void setActiveEditor(IAction action, IEditorPart targetEditor) {
		if (targetEditor instanceof IBatchClientEditor)
			this.editor = (IBatchClientEditor)targetEditor;
		else 
			this.editor = null;
	}

	public void run(IAction action) {
		if (selection != null) {
			IBatchClientEditor editor = this.editor;
			Iterator iter = selection.iterator();
			while (iter.hasNext()) {
				Object obj = iter.next();
				if (obj instanceof IRule) {
					IRule rule = (IRule)obj;
					rule.getParent().remove(rule);
				}
				
			}
			((BatchUpdateEditor)editor).setDirty(true);
			editor.refresh();
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {
		if (selection instanceof IStructuredSelection)
			this.selection = (IStructuredSelection)selection;
		else
			this.selection = null;
	}

}
