/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *  $RCSfile: $
 *  $Revision: $  $Date: $ 
 */
/**
 * 
 */
package com.ibm.ram.internal.batch.filesystem.ui;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.wizard.WizardPage;

import com.ibm.ram.internal.batch.filesystem.IRule;
import com.ibm.ram.internal.batch.filesystem.IRuleContainer;

/**
 * 
 * @author ebordeau
 * @since 7.1
 */
public abstract class RuleWizardPage extends WizardPage {
	
	private IRuleContainer ruleContainer;

	public RuleWizardPage(IRuleContainer ruleContainer, String pageName, String title, ImageDescriptor titleImage) {
		super(pageName, title, titleImage);
		this.ruleContainer = ruleContainer;
	}
	
	public abstract IRule getRule();
	
	protected IRuleContainer getRuleContainer() {
		return ruleContainer;
	}
	
}
